{% from "bootstrap5/form.html" import quick_form, render_field %}
{% extends "base.html" %}
{% block title %}SI5345{% endblock %}
{% block content %}


{% set config_form = forms["clock_config"] %}
{% set preset_form = forms["preset_select"] %}
{% set upload_form = forms["registers_upload"] %}

<h2>SI5345 report</h2>

{% if error %}
<div class="alert alert-danger">{{ error }}</div>
{% endif %}

{% for device_name, device_data in data.items() %}

{% if "error" in device_data %}
	<h3>{{ device_data['comment'] }}<span class="badge rounded-pill bg-danger">ERROR</span></h3>
	<div class="alert alert-danger">{{ device_data['error'] }}</div>
{% else %}

<h3>{{ device_data['comment'] }}
	{% if device_data["status"]["free_run_mode"] %}
	<span class="badge rounded-pill bg-primary">Free-run mode</span>
	{% endif %}

	{% if device_data["status"]["dspll_lol"] %}
	<span class="badge rounded-pill bg-danger">DSPLL Loss of Lock</span>
	{% endif %}

	{% if device_data["status"]["dspll_hold"] %}
	<span class="badge rounded-pill bg-warning">DSPLL holdover</span>
	{% endif %}

	{% if device_data["status"]["sysincal"] %}
	<span class="badge rounded-pill bg-danger">SYSINCAL</span>
	{% endif %}

	{% if device_data["status"]["cal_pll_busy"] %}
	<span class="badge rounded-pill bg-danger">CAL_PLL busy</span>
	{% endif %}

	{% if device_data["inputs"]["XAXB"]["oof"] %}
	<span class="badge rounded-pill bg-danger">XAXB_ERR</span>
	{% endif %}

	{% if device_data["inputs"]["XAXB"]["los"] %}
	<span class="badge rounded-pill bg-danger">LOSXAXB</span>
	{% endif %}

	{% if device_data["status"]["zdm_en"] %}
	<span class="badge rounded-pill bg-primary">ZDM mode</span>
	{% else %}
	<span class="badge rounded-pill bg-secondary">no ZDM</span>
	{% endif %}
</h3>


<ul>
	<li>Part number: {{ device_data["status"]["part"] }}</li>
	<li>Calculated F_vco: {{ "{:.3f}".format(device_data["status"]["f_vco"] / 1e9) }}&nbsp;GHz</li>
	<li>Current DSPLL IN_SEL[1:0] = {{ "{:b}".format(device_data["status"]["in_sel"]) }}</li>
	<li>Pads IN_SEL[1:0] = {{ "{:b}".format(device_data["status"]["in_sel_pins"]) }}</li>
	{% if device_data["status"]["out_disable_all"] %}
	<li>OUTALL_DISABLE_LOW=0</li>
	{% endif %}
	{% for error in device_data["status"]["errors"] %}
	<li class="text-danger">{{ error }}</li>
	{% endfor %}

</ul>


<h3>Inputs</h3>
<table class="table table-striped">
	<thead>
		<tr>
			<th scope="col">Name</th>
			<th scope="col">Expected Frequency [MHz]</th>
			<th scope="col">Status</th>
		</tr>
	</thead>

	<tbody>
	{% for input_name, input_data in device_data["inputs"].items() %}
		<tr scope="row">
			<td>{{input_name}}</td>
			<td>{{input_data["f_MHz"]}}</td>
			<td>
				{% if input_data["los"] %}
				<span class="badge rounded-pill bg-danger">Loss of Signal</span>
				{% endif %}

				{% if input_data["oof"] %}
				<span class="badge rounded-pill bg-warning">Out of Frequency</span>
				{% endif %}

				{% if input_data["dspll_input"] %}
				<span class="badge rounded-pill bg-success">DSPLL input</span>
				{% endif %}

				{% if input_data["oof_ref_sel"] %}
				<span class="badge rounded-pill bg-primary">OOF reference</span>
				{% endif %}
			</td>
		</tr>
	{% endfor %}
	</tbody>
</table>


<h3>Outputs</h3>

<table class="table table-striped">
	<thead>
		<tr>
			<th scope="col">Name</th>
			<th scope="col">Calculated Frequency [MHz]</th>
			<th scope="col">Enabled</th>
			<th scope="col">Format</th>
			<th scope="col">Disabled state</th>
			<th scope="col">Status</th>
		</tr>
	</thead>

	<tbody>
	{% for output_name, output_data in device_data["outputs"].items() %}
	<tr scope="row">
		<td>{{ output_data["name"] }}</td>
		<td>{{ "{:.3f}".format(output_data["frequency"] / 1e6) }}</td>

		<td>
			{% if output_data["name"] == "OUT9" and device_data["status"]["zdm_en"] %}
				<span class="badge rounded-pill bg-primary">ZDM</span>
			{% elif output_data["enable"] %}
				<span class="badge rounded-pill bg-success">Yes</span>
			{% else %}
				No
			{% endif %}
		</td>

		<td>{{ output_data["format"] }}</td>
		<td>{{ output_data["disabled_state"] }}</td>

		<td>
			{% if output_data["out_pwd_down"] %}
			<span class="badge rounded-pill bg-danger">Power down</span>
			{% endif %}

			{% if output_data["sync_en"] %}
			<span class="badge rounded-pill bg-secondary">Synchronized operation</span>
			{% endif %}
		</td>

	</tr>
	{% endfor %}
	</tbody>
</table>

<h3>Configuration</h3>

<div class="container">

	{% if preset_form.errors %}
	<div class="alert alert-danger">
	  <ul>
		{% for field, field_error in preset_form.errors.items() %}
		<li>{{preset_form[field].label.text}} - {{"; ".join(field_error)}}</li>
		{% endfor %}
	  </ul>
	</div>
	{% endif %}

	<!-- Select a configuration file preset -->
	<form method="post" class="mb-4" role=form>
		{{ preset_form.hidden_tag() }}
		<input class="form-control" id="device_name" name="device_name" required="" type="hidden" value="{{device_name}}">

		<div class="row">	  
			<div class="col-6">
			  {{ render_field(preset_form.preset_name) }}
			</div>      

			<div class="col-6 gy-4">
				<button class="btn btn-primary" type="submit" formaction="/si5345/select_preset">Apply configuration</button>
			</div>
		</div>
	</form>

	<!-- Upload a configuration file -->
	{% if upload_form.errors %}
	<div class="alert alert-danger">
	  <ul>
		{% for field, field_error in upload_form.errors.items() %}
		<li>{{upload_form[field].label.text}} - {{"; ".join(field_error)}}</li>
		{% endfor %}
	  </ul>
	</div>
	{% endif %}

	<form method="post" class="mb-4" role="form"  enctype="multipart/form-data">
		{{ upload_form.hidden_tag() }}
		<input class="form-control" id="device_name" name="device_name" required="" type="hidden" value="{{device_name}}">

		<div class="row">
			<div class="col-6">
			  {{ render_field(upload_form.file) }}
			</div>      

			<div class="col-6 g-4">
				<button class="btn btn-primary" type="submit" formaction="/si5345/upload_config">Upload configuration</button>
				
			</div>
		</div>
		<div class="row">
			<div class="col-6">
				<a class="btn btn-secondary" data-bs-toggle="collapse" href="#settingsExportHelp{{loop.index}}" role="button" aria-expanded="false" aria-controls="settingsExportHelp{{loop.index}}">
					Show how to make a register file
				</a>
			</div>
		</div>
	</form>

	<div class="container">
		<div class="collapse" id="settingsExportHelp{{loop.index}}">
			<div class="card card-body">
				<p>1. Prepare the desired configuration in ClockBuilder Pro utility</p>
				<p>2. Click "Export"</p>
				<img src="/static/img/si5345/1.jpg">
				<p>3. Select "Register File" from the tab on top</p>
				<p>4. Select "Comma Separated Values (CSV) File" as Export Type</p>
				<p>5. Uncheck "Include pre- and post-write control register writes" option</p>
				<img src="/static/img/si5345/2.jpg">
				<p>6. Exported register file should look like this:</p>
				<img src="/static/img/si5345/3.jpg">
			</div>
		</div>
	</div>

	<!-- input frequencies -->
	<h4>Specify chip inputs for frequency calculation</h4>

	{% if config_form.errors %}
	<div class="alert alert-danger">
	  <ul>
		{% for field, field_error in config_form.errors.items() %}
			<li>{{config_form[field].label.text}} - {{"; ".join(field_error)}}</li>
		{% endfor %}
	  </ul>
	</div>
	{% endif %}

	<form method="post" class="mb-4" role=form>
		{{ config_form.hidden_tag() }}
		<input class="form-control" id="device_name" name="device_name" required="" type="hidden" value="{{device_name}}">

	    <div class="row">
			<div class="col-4">
			  {{ render_field(config_form.f_xaxb_MHz, value=device_data['inputs']['XAXB']['f_MHz']) }}
			</div>
	  
			<div class="col-4">
			  {{ render_field(config_form.in_sel, value=device_data["status"]["in_sel_pins"]) }}
			</div>      
		</div>

	    <div class="row">
			<div class="col-4">
			  {{ render_field(config_form.f_in0_MHz, value=device_data['inputs']['IN_0']['f_MHz']) }}
			</div>
	  
			<div class="col-4">
			  {{ render_field(config_form.f_in2_MHz, value=device_data['inputs']['IN_2']['f_MHz']) }}
			</div>      
		</div>

		<div class="row">
			<div class="col-4">
			  {{ render_field(config_form.f_in1_MHz, value=device_data['inputs']['IN_1']['f_MHz']) }}
			</div>
	  
			<div class="col-4">
			  {{ render_field(config_form.f_in3_MHz, value=device_data['inputs']['IN_3']['f_MHz']) }}
			</div>      
		</div>

		<div class="row">
			<div class="col-auto g-4">
				<button class="btn btn-primary" type="submit" formaction="/si5345/input_config">Update</button>
			</div>
			<div class="col-auto g-4">
				<button class="btn btn-warning" type="submit" formaction="/si5345/soft_reset/{{device_name}}">Soft reset</button>
			</div>
			<div class="col-auto g-4">
				<button class="btn btn-danger" type="submit" formaction="/si5345/hard_reset/{{device_name}}">Hard reset</button>
			</div>
		</div>
	</form>	

</div>


{% endif %}

<hr>

{% endfor %}

{% endblock %}